// JavaScript Document
function submitForm(form) {
	formatResults(search(form.query.value), form.query.value);
}

function formatResults(results, keyword) {
	var resultsStr = "";

	if (results.length > 0) 
	{
		resultsStr += '<ul class="resultsList">';
		
		for (var i = 0; i < results.length; i++)
		{
			resultsStr += '<li><a href="javascript:seek(' + results[i].time + ');">' + formatResultText(results[i].text, keyword) + ': ' + formatTime(results[i].time) + '</a></li>';
		}
		
		resultsStr += "</ul>";
	}
	else
	{
		resultsStr = "No Matches Found";
	}
	document.getElementById('results').innerHTML = resultsStr;
}

//ExternalInterface callbacks
function seek(time) {
	document.getElementById('video').seek(Math.max(time - (preplay * 1000), 0));
}

function search(keyword) {
	return document.getElementById('video').search(keyword);
}

function formatTime(ms)
{
	var minutes = "";
	var seconds = "";
	
	minutes = Math.floor(ms / 1000);
	minStr = minutes.toString();
	
	if (minutes < 10)
	{
		minStr = "0" + minutes.toString();	
	}
	
	seconds = Math.floor((ms - (minutes * 1000)) / 1000 * 60);
	secStr = seconds.toString();
	
	if (seconds < 10)
	{
		secStr = "0" + seconds.toString();	
	}
	
	return minStr + "'" + secStr + '"';
}

function formatResultText(str, keyword) {
	return str.replace(keyword, '<span class="resultKeyword">' + keyword + "</span>")
}