/*  
	Animator.js 1.1.9
	
	This library is released under the BSD license:

	Copyright (c) 2006, Bernard Sumption. All rights reserved.
	
	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions are met:
	
	Redistributions of source code must retain the above copyright notice, this
	list of conditions and the following disclaimer. Redistributions in binary
	form must reproduce the above copyright notice, this list of conditions and
	the following disclaimer in the documentation and/or other materials
	provided with the distribution. Neither the name BernieCode nor
	the names of its contributors may be used to endorse or promote products
	derived from this software without specific prior written permission. 
	
	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
	AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
	ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
	ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
	DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
	SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
	CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
	LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
	OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
	DAMAGE.

*/
function Animator(A){this.setOptions(A);var B=this;this.timerDelegate=function(){B.onTimerEvent()};this.subjects=[];this.target=0;this.state=0;this.lastTime=null}Animator.prototype={setOptions:function(A){this.options=Animator.applyDefaults({interval:20,duration:400,onComplete:function(){},onStep:function(){},transition:Animator.tx.easeInOut},A)},seekTo:function(A){this.seekFromTo(this.state,A)},seekFromTo:function(B,A){this.target=Math.max(0,Math.min(1,A));this.state=Math.max(0,Math.min(1,B));this.lastTime=new Date().getTime();if(!this.intervalId){this.intervalId=window.setInterval(this.timerDelegate,this.options.interval)}},jumpTo:function(A){this.target=this.state=Math.max(0,Math.min(1,A));this.propagate()},toggle:function(){this.seekTo(1-this.target)},addSubject:function(A){this.subjects[this.subjects.length]=A;return this},clearSubjects:function(){this.subjects=[]},propagate:function(){var B=this.options.transition(this.state);for(var A=0;A<this.subjects.length;A++){if(this.subjects[A].setState){this.subjects[A].setState(B)}else{this.subjects[A](B)}}},onTimerEvent:function(){var C=new Date().getTime();var A=C-this.lastTime;this.lastTime=C;var B=(A/this.options.duration)*(this.state<this.target?1:-1);if(Math.abs(B)>=Math.abs(this.state-this.target)){this.state=this.target}else{this.state+=B}try{this.propagate()}finally{this.options.onStep.call(this);if(this.target==this.state){window.clearInterval(this.intervalId);this.intervalId=null;this.options.onComplete.call(this)}}},play:function(){this.seekFromTo(0,1)},reverse:function(){this.seekFromTo(1,0)},inspect:function(){var B="#<Animator:\n";for(var A=0;A<this.subjects.length;A++){B+=this.subjects[A].inspect()}B+=">";return B}};Animator.applyDefaults=function(C,B){B=B||{};var D,A={};for(D in C){A[D]=B[D]!==undefined?B[D]:C[D]}return A};Animator.makeArray=function(C){if(C==null){return[]}if(!C.length){return[C]}var A=[];for(var B=0;B<C.length;B++){A[B]=C[B]}return A};Animator.camelize=function(C){var E=C.split("-");if(E.length==1){return E[0]}var B=C.indexOf("-")==0?E[0].charAt(0).toUpperCase()+E[0].substring(1):E[0];for(var D=1,A=E.length;D<A;D++){var F=E[D];B+=F.charAt(0).toUpperCase()+F.substring(1)}return B};Animator.apply=function(C,B,A){if(B instanceof Array){return new Animator(A).addSubject(new CSSStyleSubject(C,B[0],B[1]))}return new Animator(A).addSubject(new CSSStyleSubject(C,B))};Animator.makeEaseIn=function(A){return function(B){return Math.pow(B,A*2)}};Animator.makeEaseOut=function(A){return function(B){return 1-Math.pow(1-B,A*2)}};Animator.makeElastic=function(A){return function(B){B=Animator.tx.easeInOut(B);return((1-Math.cos(B*Math.PI*A))*(1-B))+B}};Animator.makeADSR=function(D,B,C,A){if(A==null){A=0.5}return function(E){if(E<D){return E/D}if(E<B){return 1-((E-D)/(B-D)*(1-A))}if(E<C){return A}return A*(1-((E-C)/(1-C)))}};Animator.makeBounce=function(A){var B=Animator.makeElastic(A);return function(C){C=B(C);return C<=1?C:2-C}};Animator.tx={easeInOut:function(A){return((-Math.cos(A*Math.PI)/2)+0.5)},linear:function(A){return A},easeIn:Animator.makeEaseIn(1.5),easeOut:Animator.makeEaseOut(1.5),strongEaseIn:Animator.makeEaseIn(2.5),strongEaseOut:Animator.makeEaseOut(2.5),elastic:Animator.makeElastic(1),veryElastic:Animator.makeElastic(3),bouncy:Animator.makeBounce(1),veryBouncy:Animator.makeBounce(3)};function NumericalStyleSubject(B,C,E,D,A){this.els=Animator.makeArray(B);if(C=="opacity"&&window.ActiveXObject){this.property="filter"}else{this.property=Animator.camelize(C)}this.from=parseFloat(E);this.to=parseFloat(D);this.units=A!=null?A:"px"}NumericalStyleSubject.prototype={setState:function(E){var D=this.getStyle(E);var A=(this.property=="opacity"&&E==0)?"hidden":"";var B=0;for(var C=0;C<this.els.length;C++){try{this.els[C].style[this.property]=D}catch(F){if(this.property!="fontWeight"){throw F}}if(B++>20){return }}},getStyle:function(A){A=this.from+((this.to-this.from)*A);if(this.property=="filter"){return"alpha(opacity="+Math.round(A*100)+")"}if(this.property=="opacity"){return A}return Math.round(A)+this.units},inspect:function(){return"\t"+this.property+"("+this.from+this.units+" to "+this.to+this.units+")\n"}};function ColorStyleSubject(A,B,D,C){this.els=Animator.makeArray(A);this.property=Animator.camelize(B);this.to=this.expandColor(C);this.from=this.expandColor(D);this.origFrom=D;this.origTo=C}ColorStyleSubject.prototype={expandColor:function(B){var C,E,D,A;C=ColorStyleSubject.parseColor(B);if(C){E=parseInt(C.slice(1,3),16);D=parseInt(C.slice(3,5),16);A=parseInt(C.slice(5,7),16);return[E,D,A]}if(window.DEBUG){alert("Invalid colour: '"+B+"'")}},getValueForState:function(A,B){return Math.round(this.from[A]+((this.to[A]-this.from[A])*B))},setState:function(C){var A="#"+ColorStyleSubject.toColorPart(this.getValueForState(0,C))+ColorStyleSubject.toColorPart(this.getValueForState(1,C))+ColorStyleSubject.toColorPart(this.getValueForState(2,C));for(var B=0;B<this.els.length;B++){this.els[B].style[this.property]=A}},inspect:function(){return"\t"+this.property+"("+this.origFrom+" to "+this.origTo+")\n"}};ColorStyleSubject.parseColor=function(D){var A="#",C;if(C=ColorStyleSubject.parseColor.rgbRe.exec(D)){var B;for(var E=1;E<=3;E++){B=Math.max(0,Math.min(255,parseInt(C[E])));A+=ColorStyleSubject.toColorPart(B)}return A}if(C=ColorStyleSubject.parseColor.hexRe.exec(D)){if(C[1].length==3){for(var E=0;E<3;E++){A+=C[1].charAt(E)+C[1].charAt(E)}return A}return"#"+C[1]}return false};ColorStyleSubject.toColorPart=function(A){if(A>255){A=255}var B=A.toString(16);if(A<16){return"0"+B}return B};ColorStyleSubject.parseColor.rgbRe=/^rgb\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\)$/i;ColorStyleSubject.parseColor.hexRe=/^\#([0-9a-fA-F]{3}|[0-9a-fA-F]{6})$/;function DiscreteStyleSubject(B,C,E,D,A){this.els=Animator.makeArray(B);this.property=Animator.camelize(C);this.from=E;this.to=D;this.threshold=A||0.5}DiscreteStyleSubject.prototype={setState:function(C){var A=0;for(var B=0;B<this.els.length;B++){this.els[B].style[this.property]=C<=this.threshold?this.from:this.to}},inspect:function(){return"\t"+this.property+"("+this.from+" to "+this.to+" @ "+this.threshold+")\n"}};function CSSStyleSubject(D,M,J){D=Animator.makeArray(D);this.subjects=[];if(D.length==0){return }var A,N,B;if(J){B=this.parseStyle(M,D[0]);N=this.parseStyle(J,D[0])}else{N=this.parseStyle(M,D[0]);B={};for(A in N){B[A]=CSSStyleSubject.getStyle(D[0],A)}}var A;for(A in B){if(B[A]==N[A]){delete B[A];delete N[A]}}var A,H,E,I,L,K;for(A in B){var G=String(B[A]);var C=String(N[A]);if(N[A]==null){if(window.DEBUG){alert("No to style provided for '"+A+'"')}continue}if(L=ColorStyleSubject.parseColor(G)){K=ColorStyleSubject.parseColor(C);I=ColorStyleSubject}else{if(G.match(CSSStyleSubject.numericalRe)&&C.match(CSSStyleSubject.numericalRe)){L=parseFloat(G);K=parseFloat(C);I=NumericalStyleSubject;E=CSSStyleSubject.numericalRe.exec(G);var F=CSSStyleSubject.numericalRe.exec(C);if(E[1]!=null){H=E[1]}else{if(F[1]!=null){H=F[1]}else{H=F}}}else{if(G.match(CSSStyleSubject.discreteRe)&&C.match(CSSStyleSubject.discreteRe)){L=G;K=C;I=DiscreteStyleSubject;H=0}else{if(window.DEBUG){alert("Unrecognised format for value of "+A+": '"+B[A]+"'")}continue}}}this.subjects[this.subjects.length]=new I(D,A,L,K,H)}}CSSStyleSubject.prototype={parseStyle:function(B,C){var G={};if(B.indexOf(":")!=-1){var I=B.split(";");for(var E=0;E<I.length;E++){var D=CSSStyleSubject.ruleRe.exec(I[E]);if(D){G[D[1]]=D[2]}}}else{var A,H,F;F=C.className;C.className=B;for(var E=0;E<CSSStyleSubject.cssProperties.length;E++){A=CSSStyleSubject.cssProperties[E];H=CSSStyleSubject.getStyle(C,A);if(H!=null){G[A]=H}}C.className=F}return G},setState:function(B){for(var A=0;A<this.subjects.length;A++){this.subjects[A].setState(B)}},inspect:function(){var B="";for(var A=0;A<this.subjects.length;A++){B+=this.subjects[A].inspect()}return B}};CSSStyleSubject.getStyle=function(B,C){var A;if(document.defaultView&&document.defaultView.getComputedStyle){A=document.defaultView.getComputedStyle(B,"").getPropertyValue(C);if(A){return A}}C=Animator.camelize(C);if(B.currentStyle){A=B.currentStyle[C]}return A||B.style[C]};CSSStyleSubject.ruleRe=/^\s*([a-zA-Z\-]+)\s*:\s*(\S(.+\S)?)\s*$/;CSSStyleSubject.numericalRe=/^-?\d+(?:\.\d+)?(%|[a-zA-Z]{2})?$/;CSSStyleSubject.discreteRe=/^\w+$/;CSSStyleSubject.cssProperties=["azimuth","background","background-attachment","background-color","background-image","background-position","background-repeat","border-collapse","border-color","border-spacing","border-style","border-top","border-top-color","border-right-color","border-bottom-color","border-left-color","border-top-style","border-right-style","border-bottom-style","border-left-style","border-top-width","border-right-width","border-bottom-width","border-left-width","border-width","bottom","clear","clip","color","content","cursor","direction","display","elevation","empty-cells","css-float","font","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","height","left","letter-spacing","line-height","list-style","list-style-image","list-style-position","list-style-type","margin","margin-top","margin-right","margin-bottom","margin-left","max-height","max-width","min-height","min-width","orphans","outline","outline-color","outline-style","outline-width","overflow","padding","padding-top","padding-right","padding-bottom","padding-left","pause","position","right","size","table-layout","text-align","text-decoration","text-indent","text-shadow","text-transform","top","vertical-align","visibility","white-space","width","word-spacing","z-index","opacity","outline-offset","overflow-x","overflow-y"];function AnimatorChain(C,A){this.animators=C;this.setOptions(A);for(var B=0;B<this.animators.length;B++){this.listenTo(this.animators[B])}this.forwards=false;this.current=0}AnimatorChain.prototype={setOptions:function(A){this.options=Animator.applyDefaults({resetOnPlay:true},A)},play:function(){this.forwards=true;this.current=-1;if(this.options.resetOnPlay){for(var A=0;A<this.animators.length;A++){this.animators[A].jumpTo(0)}}this.advance()},reverse:function(){this.forwards=false;this.current=this.animators.length;if(this.options.resetOnPlay){for(var A=0;A<this.animators.length;A++){this.animators[A].jumpTo(1)}}this.advance()},toggle:function(){if(this.forwards){this.seekTo(0)}else{this.seekTo(1)}},listenTo:function(A){var B=A.options.onComplete;var C=this;A.options.onComplete=function(){if(B){B.call(A)}C.advance()}},advance:function(){if(this.forwards){if(this.animators[this.current+1]==null){return }this.current++;this.animators[this.current].play()}else{if(this.animators[this.current-1]==null){return }this.current--;this.animators[this.current].reverse()}},seekTo:function(A){if(A<=0){this.forwards=false;this.animators[this.current].seekTo(0)}else{this.forwards=true;this.animators[this.current].seekTo(1)}}};function Accordion(J){this.setOptions(J);var B=this.options.initialSection,G;if(this.options.rememberance){G=document.location.hash.substring(1)}this.rememberanceTexts=[];this.ans=[];var F=this;for(var C=0;C<this.options.sections.length;C++){var A=this.options.sections[C];var D=new Animator(this.options.animatorOptions);var I=this.options.from+(this.options.shift*C);var H=this.options.to+(this.options.shift*C);D.addSubject(new NumericalStyleSubject(A,this.options.property,I,H,this.options.units));D.jumpTo(0);var E=this.options.getActivator(A);E.index=C;E.onclick=function(){F.show(this.index)};this.ans[this.ans.length]=D;this.rememberanceTexts[C]=E.innerHTML.replace(/\s/g,"");if(this.rememberanceTexts[C]===G){B=C}}this.show(B)}Accordion.prototype={setOptions:function(A){this.options=Object.extend({sections:null,getActivator:function(B){return document.getElementById(B.getAttribute("activator"))},shift:0,initialSection:0,rememberance:true,animatorOptions:{}},A||{})},show:function(B){for(var A=0;A<this.ans.length;A++){this.ans[A].seekTo(A>B?1:0)}if(this.options.rememberance){document.location.hash=this.rememberanceTexts[B]}}};